module Awslive
  class InputPrepareScheduleAction
    IMMEDIATE_HASH = {
        :action_name => "action_name",
        :schedule_action_start_settings => {
            :immediate_mode_schedule_action_start_settings => {}
        },
        :schedule_action_settings => {
            :input_prepare_settings => {
                :input_attachment_name_reference => "input_name"
            }
        }
    }

    def get_immediate_schedule_action( input_ref_name)
      action_hash = IMMEDIATE_HASH.clone
      action_hash[:action_name] = "#{get_action_id}"
      action_hash[:schedule_action_settings][:input_prepare_settings][:input_attachment_name_reference] = "#{input_ref_name}"
      action_hash
    end

    def get_action_id
      Time.now.to_i
    end
  end
end
