module Awslive
  class InputSwitchScheduleAction

    FOLLOW_HASH = {
            action_name: "f1",
            schedule_action_start_settings: {
                follow_mode_schedule_action_start_settings: {
                    reference_action_name: "imm",
                    follow_point: "END"
                }
            },
            schedule_action_settings: {
                input_switch_settings: {
                    input_attachment_name_reference: "input1",
                    url_path: []
                }
            }
        }

    IMMEDIATE_HASH = {
            :action_name => "action_name",
            :schedule_action_start_settings => {
                :immediate_mode_schedule_action_start_settings => {}
            },
            :schedule_action_settings => {
                :input_switch_settings => {
                    :input_attachment_name_reference => "input_name",
                    :url_path => []
                }
            }
        }

    def get_immediate_schedule_action( input_ref_name, urlpath = nil)
      action_hash = IMMEDIATE_HASH.clone
      action_hash[:action_name] = "#{get_action_id}"
      action_hash[:schedule_action_settings][:input_switch_settings][:input_attachment_name_reference] = "#{input_ref_name}"
      action_hash[:schedule_action_settings][:input_switch_settings][:url_path] = [ urlpath ] unless urlpath.nil?
      action_hash
    end

    def get_follow_schedule_action(follow_input, trigger_input, urlpath = nil)
      action_hash = FOLLOW_HASH.clone
      action_hash[:action_name] = "#{get_action_id}"
      action_hash[:schedule_action_start_settings][:follow_mode_schedule_action_start_settings][:reference_action_name] = "#{follow_input}"
      action_hash[:schedule_action_settings][:input_switch_settings][:input_attachment_name_reference] = "#{trigger_input}"
      action_hash[:schedule_action_settings][:input_switch_settings][:url_path] = [ urlpath ] unless urlpath.nil?
      action_hash
    end

    def get_action_id
      Time.now.to_i
    end

  end
end
