module Awslive
  class PauseScheduleAction

    PAUSE_HASH = {
        :action_name => "pause",
        :schedule_action_start_settings => {
            :fixed_mode_schedule_action_start_settings => {
                :time => "2019-12-22T14:36:01.302Z"
            }
        },
        :schedule_action_settings => {
            :pause_state_settings => {
                :pipelines => []
            }
        }
    }

    def get_pause_schedule_action(type)
      action_hash = PAUSE_HASH.clone
      action_hash[:action_name] = "#{get_action_id}"
      exec_time = ( Time.now.utc + 30 ).iso8601
      action_hash[:schedule_action_start_settings][:fixed_mode_schedule_action_start_settings][:time] = "#{exec_time}"
      pipelines = []
      pipelines << {
          pipeline_id: "PIPELINE_0"
      }
      if type == "STANDARD"
        pipelines << {
            pipeline_id: "PIPELINE_1"
        }
      end
      action_hash[:schedule_action_settings][:pause_state_settings][:pipelines] = pipelines
      puts "#{action_hash}"
      action_hash
    end

    def get_unpause_schedule_action
      action_hash = PAUSE_HASH.clone
      action_hash[:action_name] = "#{get_action_id}"
      exec_time = ( Time.now.utc + 30 ).iso8601
      action_hash[:schedule_action_start_settings][:fixed_mode_schedule_action_start_settings][:time] = "#{exec_time}"
      action_hash
    end

    def get_action_id
      Time.now.to_i
    end
  end
end
